%define api 8.6
%define major 0
%define libname %mklibname %{name} %{api} %{major}
%define devname %mklibname %{name} -d

Summary:	Tk GUI toolkit for Tcl
Name:		tk
Version:	8.6.4
Release:	1
License:	BSD
Group:		System/Libraries
Url:		http://tcl.tk
Source0:	http://downloads.sourceforge.net/tcl/%{name}%{version}-src.tar.gz
Source1:	icons.tcl
Patch0:		tk8.6.1-soname.patch
Patch1:		tk8.6b1-fix_Xft_linkage.patch
Patch2:		tk-8.6.1-make.patch
BuildRequires:	chrpath
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(tcl) >= %{version}
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xft)
BuildRequires:	pkgconfig(xscrnsaver)
Requires:	%{libname} = %{EVRD}
Provides:	%{_bindir}/wish

%description
Tk is a X Windows widget set designed to work closely with the tcl
scripting language. It allows you to write simple programs with full
featured GUIs in only a little more time then it takes to write a
text based interface. Tcl/Tk applications can also be run on Windows
and Macintosh platforms.

%files
%{_bindir}/*
%{_libdir}/%{name}%{api}
%{_datadir}/%{name}%{api}
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_mandir}/mann/*

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Shared libraries for %{name}
Group:		System/Libraries
Conflicts:	%{_lib}tk8.6 < 8.6.4
Obsoletes:	%{_lib}tk8.6 < 8.6.4

%description -n %{libname}
Tk is a X Windows widget set designed to work closely with the tcl
scripting language. It allows you to write simple programs with full
featured GUI's in only a little more time then it takes to write a
text based interface. Tcl/Tk applications can also be run on Windows
and Macintosh platforms.

%files -n %{libname}
%{_libdir}/libtk%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/Other
Requires:	%{name} = %{EVRD}
Requires:	%{libname} = %{EVRD}
Requires:	pkgconfig(x11)
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
This package contains development files for %{name}.

%files -n %{devname} -f %{devname}.files
%dir %{_includedir}/tk%{version}
%dir %{_includedir}/tk%{version}/compat
%dir %{_includedir}/tk%{version}/generic
%dir %{_includedir}/tk%{version}/unix
%{_includedir}/tk%{version}/compat/*.h
%{_includedir}/tk%{version}/generic/*.h
%{_includedir}/tk%{version}/unix/*.h
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/tkConfig.sh
%{_libdir}/pkgconfig/*.pc

#----------------------------------------------------------------------------

%prep
%setup -qn %{name}%{version}
%patch0 -p1 -b .soname~
%patch1 -p1 -b .Xft~
%patch2 -p1 -b .make~
# Replace native icons.tcl - it contains  PNG data
# obtained using old libpng and has problems with new libpng
# The new one contains PNG data created using
# new libpng
cp -f %{SOURCE1} library

%build
pushd unix
    autoconf
    %configure2_5x \
	--enable-threads \
	--enable-64bit \
	--disable-rpath \
	--with-tcl=%{_libdir} \
	--includedir=%{_includedir}/tk%{version}
    %make TK_LIBRARY=%{_datadir}/%{name}%{api}

    cp libtk%{api}.so libtk%{api}.so.%{major}
#    make test
popd

%install
# If %{_libdir} is not %{_prefix}/lib, then define EXTRA_TCLLIB_FILES
# which contains actual non-architecture-dependent tcl code.
if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    EXTRA_TCLLIB_FILES="%{buildroot}%{_prefix}/lib/*"
fi

%makeinstall -C unix TK_LIBRARY=%{buildroot}%{_datadir}/%{name}%{api}

# create the arch-dependent dir
mkdir -p %{buildroot}%{_libdir}/%{name}%{api}

# fix libname
mv %{buildroot}%{_libdir}/libtk%{api}.so %{buildroot}%{_libdir}/libtk%{api}.so.%{major}
ln -snf libtk%{api}.so.%{major} %{buildroot}%{_libdir}/libtk%{api}.so

# install all headers
install -d %{buildroot}%{_includedir}/tk%{version}/compat
install -d %{buildroot}%{_includedir}/tk%{version}/generic
install -d %{buildroot}%{_includedir}/tk%{version}/unix
install -m0644 compat/*.h %{buildroot}%{_includedir}/tk%{version}/compat/
install -m0644 generic/*.h %{buildroot}%{_includedir}/tk%{version}/generic/
install -m0644 unix/*.h %{buildroot}%{_includedir}/tk%{version}/unix/

# (tpg) compat issues
cp -f %{buildroot}%{_includedir}/tk%{version}/unix/tkUnixPort.h %{buildroot}%{_includedir}/tk%{version}/generic/

pushd %{buildroot}%{_bindir}
    ln -sf wish* wish
popd

pushd %{buildroot}%{_libdir}
cat > lib%{name}.so << EOF
/* GNU ld script
   We want -l%{name} to include the actual system library,
   which is lib%{name}%{api}.so.%{major}  */
INPUT ( -l%{name}%{api} )
EOF
popd

# fix config script
perl -pi -e "s|-L`pwd`/unix\b|-L%{_libdir}|g" %{buildroot}%{_libdir}/tkConfig.sh
perl -pi -e "s|`pwd`/unix/lib|%{_libdir}/lib|g" %{buildroot}%{_libdir}/tkConfig.sh
perl -pi -e "s|`pwd`|%{_includedir}/tk%{version}|g" %{buildroot}%{_libdir}/tkConfig.sh

# and let it be found (we don't look in /usr/lib any more)
ln -s %{_libdir}/%{name}Config.sh %{buildroot}/%{_libdir}/%{name}%{api}/%{name}Config.sh

# Arrangements for lib64 platforms
echo "# placeholder" >> %{devname}.files
if [[ "%{_lib}" != "lib" ]]; then
    mkdir -p %{buildroot}%{_prefix}/lib
    ln -s %{_libdir}/tkConfig.sh %{buildroot}%{_prefix}/lib/tkConfig.sh
    echo "%{_prefix}/lib/tkConfig.sh" >> %{devname}.files
fi

# (fc) make sure .so files are writable by root
chmod 755 %{buildroot}%{_libdir}/*.so*

# (tpg) nuke rpath
chrpath -d %{buildroot}%{_libdir}/libtk%{api}.so.%{major}


%changelog

* Fri Jun 26 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 8.6.4-1
- (b5f4087) New version 8.6.4
- (b5f4087) Add make patch from Fedora to fix permissions
- (b5f4087) Properly name library package (follow library packaging policy)
- (b5f4087) Spec cleanup


